import 'package:flutter/material.dart';

class RefreshPaginationList extends StatelessWidget{
  late ScrollController _controller;
  Function refreshList, swipeList;
  Function listItem;
  int totalItems = 0;
  bool refreshLoader = false, swipeLoader = false;

  RefreshPaginationList(
      {required this.listItem,
        required this.refreshList,
        required this.swipeList,
        required this.totalItems,
        required this.refreshLoader,
        required this.swipeLoader});

  void setScrollListener() {
    _controller.addListener(() {
      if (_controller.position.pixels <= -200) {
        refreshList();
      }
      if (_controller.position.maxScrollExtent == _controller.position.pixels) {
        swipeList();
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    _controller = ScrollController();
    setScrollListener();
    return Column(
      children: [
        refreshLoader ? loaderWidget("Refresh...") : SizedBox(),
        Expanded(
          child: ListView.builder(
              itemCount: totalItems,
              itemBuilder: (context, index) => listItem(index)),
        ),
        swipeLoader ? loaderWidget("Wait...") : SizedBox(),
      ],
    );
  }

  loaderWidget(String text) {
    return Stack(
      alignment: Alignment.center,
      children: [
        const LinearProgressIndicator(
          color: Colors.teal,
          minHeight: 50,
          backgroundColor: Colors.grey,
        ),
        Text(text)
      ],
    );
  }
}
